public class Factorial {
    public static void main(String[] args) {
        iterativeFactorial(5);

        System.out.println("Recursive Approach");
        recursiveFactorial(5);
    }

    public static int iterativeFactorial(int n) {
        int result = 1; // fencepost
        System.out.println("Iterative Approach");
        System.out.print(n+"! = 1");
        for (int i = 2; i <= n; i++) {
            result *= i;
            System.out.print(" * " + i);
        }
        System.out.println(" = " + result);
        return result;
    }

    public static int recursiveFactorial(int n) {
        if (n == 1) {
            System.out.println("base case: return 1");
            return 1;
        } else {
            System.out.println("recursive case: " + n + " * factorial of " + (n - 1));
            return n * recursiveFactorial(n - 1);
        }
    }
}
